//---------------------------------------------------------------------------
// Roman Brik, TE010062, 2. ronk DI, KPI FEI TU Koice
// Dtum: Marec - Mj 2003
// Predmet: Objektovo orientovan programovanie
// Sbor: Hudba.cpp - zdrojov kd tried Hudba, Nakup a Oddelenie
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Tovar.h"
#include "Hudba.h"
//---------------------------------------------------------------------------
// Trieda Hudba
//---------------------------------------------------------------------------
// konstruktor Hudba
__fastcall Hudba::Hudba()
{
  Interpret = "";
  NazovAlbumu = "";
  Nosic = HN_NONE;
  Zaner = ZN_NONE;
  SadzbaDPH = 0.0;
}
//---------------------------------------------------------------------------
AnsiString __fastcall Hudba::getOddelenie()
{
  return "Nkupno-predajn oddelenie - Hudba";
}
//---------------------------------------------------------------------------
AnsiString __fastcall Hudba::getDruh()
{
  return "Hudobn nosi";
}
//---------------------------------------------------------------------------
void __fastcall Hudba::setInterpret(AnsiString Interpret)
{
  this->Interpret = Interpret;
}
//---------------------------------------------------------------------------
AnsiString __fastcall Hudba::getInterpret()
{
  return Interpret;
}
//---------------------------------------------------------------------------
void __fastcall Hudba::setNazovAlbumu(AnsiString NazovAlbumu)
{
  this->NazovAlbumu = NazovAlbumu;
}
//---------------------------------------------------------------------------
AnsiString __fastcall Hudba::getNazovAlbumu()
{
  return NazovAlbumu;
}
//---------------------------------------------------------------------------
void __fastcall Hudba::setNosic(TNosic Nosic)
{
  this->Nosic = Nosic;
}
//---------------------------------------------------------------------------
TNosic __fastcall Hudba::getNosic()
{
  return Nosic;
}
//---------------------------------------------------------------------------
void __fastcall Hudba::setZaner(TZaner Zaner)
{
  this->Zaner = Zaner;
}
//---------------------------------------------------------------------------
TZaner __fastcall Hudba::getZaner()
{
  return Zaner;
}
//---------------------------------------------------------------------------
void __fastcall Hudba::setSadzbaDPH(float SadzbaDPH)
{
  this->SadzbaDPH = SadzbaDPH;
}
//---------------------------------------------------------------------------
float __fastcall Hudba::getSadzbaDPH()
{
  return SadzbaDPH;
}
//---------------------------------------------------------------------------
bool __fastcall Hudba::operator <(Hudba& HC)
{ // pretazeny operator '<'
//  if (this->Interpret.AnsiCompare(HC.Interpret) < 0)
  if (this->getNazov().AnsiCompare(HC.getNazov()) < 0)
    return true;
  else
    return false;
}
//---------------------------------------------------------------------------
// Trieda Nakup
//---------------------------------------------------------------------------
// konstruktor Nakup
__fastcall Nakup::Nakup()
{
  DatumNakupu = TDateTime::CurrentDateTime();
  CenaNakupu = 0.0;
  ZoznamNakupu = NULL;
  pDalsi = NULL;
}
//---------------------------------------------------------------------------
void __fastcall Nakup::setDatumNakupu(TDateTime DatumNakupu)
{
  this->DatumNakupu = DatumNakupu;
}
//---------------------------------------------------------------------------
TDateTime __fastcall Nakup::getDatumNakupu()
{
  return DatumNakupu;
}
//---------------------------------------------------------------------------
void __fastcall Nakup::setCenaNakupu(float CenaNakupu)
{
  this->CenaNakupu = CenaNakupu;
}
//---------------------------------------------------------------------------
float __fastcall Nakup::getCenaNakupu()
{
  return CenaNakupu;
}
//---------------------------------------------------------------------------
// Trieda Oddelenie
//---------------------------------------------------------------------------
// konstruktor Oddelenie
__fastcall Oddelenie::Oddelenie()
{
  tSortEnable = false;
  nSortType = 0;
  PrvyTovar = NULL;
  PrvyNakup = NULL;
  ZoznamTovaru = NULL;
  ZoznamNakupov = NULL;
}
//---------------------------------------------------------------------------
Hudba* __fastcall Oddelenie::FindAncestorTovar(Hudba *HA)
{ // Najde predchodcu tovaru HA, ak existuje, inak vrati NULL
  Hudba *HX;

  for (int i = 0; i < ZoznamTovaru->Count; i++) {
    HX = (Hudba *)ZoznamTovaru->Items[i];
    if (HX->pDalsi == HA)
      return HX;
  }
  return NULL;
}
//---------------------------------------------------------------------------
void __fastcall Oddelenie::SortTovar()
{ // Bubble sort - zotriedi zoznam tovarov podla celeho mena
  Hudba *HS, *HW, *HX, *HY;
  bool bZamena;

  if (tSortEnable == false || PrvyTovar == NULL)
    return;
  HW = NULL;
  do {  // najvacsi prvok sa posuva na koniec zoznamu
    bZamena = false;  // budeme sledovat ci sa zamienali prvky
    HS = PrvyTovar;
    while (HS->pDalsi != HW) {
      if (*HS->pDalsi < *HS) { // porovnanie cez pretazeny operator '<'
//      if (HS->getNazov().AnsiCompare(HS->pDalsi->getNazov()) > 0) {
        HX = HS->pDalsi;             // HX - naslednik HS
        HY = FindAncestorTovar(HS);  // HY - predchodca HS
        HS->pDalsi = HX->pDalsi;
        HX->pDalsi = HS;
        if (HS == PrvyTovar)
          PrvyTovar = HX;
        else
          HY->pDalsi = HX;
        HS = HX;
        bZamena = true;
      }
      HS = HS->pDalsi;
    }
    HW = HS;
  } while (bZamena == true && HS != PrvyTovar);
}
//---------------------------------------------------------------------------
void __fastcall Oddelenie::TovarSorting(bool Enable)
{ // zapne alebo vypne Triedenie zoznamu tovarov
  if (Enable) {
    tSortEnable = true;
    SortTovar();
  }
  else
    tSortEnable = false;
}
//---------------------------------------------------------------------------
Hudba* __fastcall Oddelenie::TovarByIndex(int Idx)
{ // Vrati pointer na tovar podla jeho indexu v (ne)zoradenom zozname
  int iI = Idx;
  Hudba *XH = PrvyTovar;

  if (Idx >= ZoznamTovaru->Count)
    return NULL;
  while (iI > 0) {
    XH = XH->pDalsi;
    iI--;
  }
  return XH;
}
//---------------------------------------------------------------------------
int __fastcall Oddelenie::IndexOfTovar(Hudba *HI)
{ // Vrati index tovaru HI, ak sa nenajde vrati -1
  if (ZoznamTovaru->Count > 0) {
    for (int i = 0; i < ZoznamTovaru->Count; i++) {
      if (HI == TovarByIndex(i))
        return i;
    }
  }
  return -1;
}
//---------------------------------------------------------------------------
void __fastcall Oddelenie::AddTovar(Hudba *HP)
{ // Prida tovar na koniec zoznamu
  if (ZoznamTovaru->Count > 0) {
    Hudba *XXH = FindAncestorTovar(NULL);
    XXH->pDalsi = HP;
  }
  HP->pDalsi = NULL;
  ZoznamTovaru->Add(HP);
  SortTovar();
}
//---------------------------------------------------------------------------
void __fastcall Oddelenie::DeleteTovar(Hudba *HD)
{ // zmaze z databazy jeden z tovarov
  if (HD == PrvyTovar)
    PrvyTovar = HD->pDalsi;
  else {
    Hudba *YYH = FindAncestorTovar(HD);
    YYH->pDalsi = HD->pDalsi;
  }
  ZoznamTovaru->Delete(ZoznamTovaru->IndexOf(HD));
  delete HD;
}
//---------------------------------------------------------------------------
void __fastcall Oddelenie::UpdateTovar()
{ // vytvori povodny nezotriedeny zoznam ako po nacitani zo suboru
  tSortEnable = false;                       // a zakaze triedenie
  if (ZoznamTovaru->Count == 0) {
    PrvyTovar = NULL;
    return;
  }

  PrvyTovar = (Hudba *)ZoznamTovaru->Items[0];
  Hudba *HU = PrvyTovar;
  for (int i = 1; i < ZoznamTovaru->Count; i++) {
     HU->pDalsi = (Hudba *)ZoznamTovaru->Items[i];
     HU = HU->pDalsi;
  }
  HU->pDalsi = NULL;
}
//---------------------------------------------------------------------------
int __fastcall Oddelenie::FindTovar(const AnsiString& AF, int index)
{ // vrati index tovaru v zozname, ktoreho Nazov obsahuje podretazec 'AF'.
  // Ak sa hladany podretazec nenajde, vrati -1. Vyhladavanie prebieha od
  // tovaru s indexom 'index'. Je ignorovana velkost pismen.
  Hudba *HF;

  if (ZoznamTovaru->Count > 0) {
    for (int i = (index < 0) ? 0 : index; i < ZoznamTovaru->Count; i++) {
      HF = TovarByIndex(i);
      if (HF->getNazov().LowerCase().Pos(AF.LowerCase()) > 0)
        return i;
    }
  }
  return -1;
}
//---------------------------------------------------------------------------
Nakup* __fastcall Oddelenie::FindAncestorNakup(Nakup *NA)
{ // Najde predchodcu nakupu NA, ak existuje, inak vrati NULL
  Nakup *NX;

  for (int i = 0; i < ZoznamNakupov->Count; i++) {
    NX = (Nakup *)ZoznamNakupov->Items[i];
    if (NX->pDalsi == NA)
      return NX;
  }
  return NULL;
}
//---------------------------------------------------------------------------
Nakup* __fastcall Oddelenie::NakupByIndex(int idx)
{ // Vrati pointer na nakup podla jeho indexu v zoradenom zozname
  int iI = idx;
  Nakup *XN = PrvyNakup;

  if (idx < 0 || idx >= ZoznamNakupov->Count)
    return NULL;
  while (iI > 0) {
    XN = XN->pDalsi;
    iI--;
  }
  return XN;
}
//---------------------------------------------------------------------------
void __fastcall Oddelenie::SortNakup()
{ // Bubble sort - zotriedi nakupy podla datumu alebo ceny
  Nakup *NS, *NW, *NX, *NY;
  bool bZamena;

  if (PrvyNakup == NULL)
    return;
  NW = NULL;
  do {  // najvacsi prvok sa posuva na koniec zoznamu
    bZamena = false;  // budeme sledovat ci sa zamienali prvky
    NS = PrvyNakup;
    while (NS->pDalsi != NW) {
      if ((nSortType == 0 && NS->getDatumNakupu() > NS->pDalsi->getDatumNakupu())
          || (nSortType == 1 && NS->getCenaNakupu() > NS->pDalsi->getCenaNakupu())) {
        NX = NS->pDalsi;             // NX - naslednik NS
        NY = FindAncestorNakup(NS);  // NY - predchodca NS
        NS->pDalsi = NX->pDalsi;
        NX->pDalsi = NS;
        if (NS == PrvyNakup)
          PrvyNakup = NX;
        else
          NY->pDalsi = NX;
        NS = NX;
        bZamena = true;
      }
      NS = NS->pDalsi;
    }
    NW = NS;
  } while (bZamena == true && NS != PrvyNakup);
}
//---------------------------------------------------------------------------
void __fastcall Oddelenie::NakupSorting(int Type)
{
  nSortType = Type;
  SortNakup();
}
//---------------------------------------------------------------------------
void __fastcall Oddelenie::AddNakup(Nakup * NP)
{ // Prida nakup na koniec zoznamu
  if (ZoznamNakupov->Count > 0) {
    Nakup *XN = FindAncestorNakup(NULL);
    XN->pDalsi = NP;
  }
  NP->pDalsi = NULL;
  ZoznamNakupov->Add(NP);
  SortNakup();
}
//---------------------------------------------------------------------------
Nakup* __fastcall Oddelenie::FindNakup(WORD Month, int &Nak)
{
  Nakup *NF;
  WORD wY, wCY, wM, wD;

  if (ZoznamNakupov->Count == 0)
    return NULL;

  DecodeDate(Now(), wCY, wM, wD);
  while (Nak < ZoznamNakupov->Count) {
    NF = (Nakup *)ZoznamNakupov->Items[Nak];
    if (Month == 0 &&  wY == wCY)
      return NF;
    NF->getDatumNakupu().DecodeDate(&wY, &wM, &wD);
    if (wM == Month && wY == wCY)
      return NF;
    Nak++;
  }
  return NULL;
}
//---------------------------------------------------------------------------

