//---------------------------------------------------------------------------
// Roman Brik, TE010062, 2. ronk DI, KPI FEI TU Koice
// Dtum: Marec - Mj 2003
// Predmet: Objektovo orientovan programovanie
// Sbor: Hudba.h - hlavikov sbor s definciou tried Hudba, Nakup
//        a Oddelenie
//---------------------------------------------------------------------------
#ifndef HudbaH
#define HudbaH
//---------------------------------------------------------------------------
enum TNosic {HN_NONE, HN_MC, HN_LP, HN_CD, HN_MD, HN_DVD, DN_VHS};
enum TZaner {ZN_NONE, ZN_ACAPPELLA, ZN_BLUEGRASS, ZN_BLUES, ZN_CLASSIC,
             ZN_COUNTRY, ZN_DANCE, ZN_DISCO, ZN_FOLK, ZN_FOLKLORE, ZN_FUNKY,
             ZN_GOSPEL, ZN_HEAVYMETAL, ZN_HOUSE, ZN_JAZZ, ZN_POP, ZN_PUNK,
             ZN_RAP, ZN_ROCK, ZN_SPEECH, ZN_TECHNO};
//---------------------------------------------------------------------------
// Trieda Hudba odvodena od abstraktnej triedy Tovar
class Hudba : public Tovar {
private: // clenske premenne viditelne len metodami tejto triedy
  AnsiString Interpret;
  AnsiString NazovAlbumu;
  TNosic Nosic;
  TZaner Zaner;
  float SadzbaDPH;

public:
  Hudba *pDalsi;      // odkaz na dalsi tovar v zozname
  DWORD dwFilePos;    // pozicia v subore, kde sa nachadza zaznam

public:
// konstruktor
  __fastcall Hudba();

// definicie virtualnych metod z triedy Tovar
  virtual AnsiString __fastcall getOddelenie();
  virtual AnsiString __fastcall getDruh();

// clenske metody
  void __fastcall setInterpret(AnsiString Interpret);
  AnsiString __fastcall getInterpret();
  void __fastcall setNazovAlbumu(AnsiString NazovAlbumu);
  AnsiString __fastcall getNazovAlbumu();
  void __fastcall setNosic(TNosic Nosic);
  TNosic __fastcall getNosic();
  void __fastcall setZaner(TZaner Zaner);
  TZaner __fastcall getZaner();
  void __fastcall setSadzbaDPH(float SadzbaDPH);
  float __fastcall getSadzbaDPH();

// pretazenie operatora '<'
  bool __fastcall operator <(Hudba& HC);
};
//---------------------------------------------------------------------------
// Struktura jednej polozky v nakupe
struct PolozkaNakupu {
  AnsiString Nazov;
  float Mnozstvo;
  float Cena;
};
//---------------------------------------------------------------------------
// Trieda Nakup
class Nakup {
private: // clenske premenne viditelne len metodami tejto triedy
  TDateTime DatumNakupu;
  float CenaNakupu;

public:
  TList *ZoznamNakupu;
  Nakup *pDalsi;      // odkaz na dalsi nakup v zozname
  DWORD dwFilePos;    // pozicia v subore, kde sa nachadza zaznam

public:
// konstruktor
  __fastcall Nakup();

// clenske metody
  void __fastcall setDatumNakupu(TDateTime DatumNakupu);
  TDateTime __fastcall getDatumNakupu();
  void __fastcall setCenaNakupu(float CenaNakupu);
  float __fastcall getCenaNakupu();
};
//---------------------------------------------------------------------------
// Trieda Oddelenie
class Oddelenie {
private:
  bool tSortEnable;     // povolenie triedenia
  Hudba* __fastcall FindAncestorTovar(Hudba *HA);
  void __fastcall SortTovar();
  int nSortType;        // typ triedenia nakupov
  Nakup* __fastcall FindAncestorNakup(Nakup *NA);
  void __fastcall SortNakup();

public:
// clenske premenne zoznamov
  TList* ZoznamTovaru;
  TList* ZoznamNakupov;
  Hudba* PrvyTovar;
  Nakup* PrvyNakup;

// konstruktor
  __fastcall Oddelenie();
// clenske metody
  void __fastcall TovarSorting(bool Enable);
  Hudba* __fastcall TovarByIndex(int Idx);
  int __fastcall IndexOfTovar(Hudba *HI);
  void __fastcall AddTovar(Hudba *HP);
  void __fastcall DeleteTovar(Hudba *HD);
  void __fastcall UpdateTovar();
  int __fastcall FindTovar(const AnsiString& AF, int index = 0);
  Nakup* __fastcall NakupByIndex(int idx);
  void __fastcall AddNakup(Nakup *NA);
  void __fastcall NakupSorting(int Type);
  Nakup* __fastcall FindNakup(WORD Month, int &Nak);
};
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------

