//---------------------------------------------------------------------------
// Roman Brik, TE010062, 2. ronk DI, KPI FEI TU Koice
// Dtum: Marec - Mj 2003
// Predmet: Objektovo orientovan programovanie
// Sbor: Main.cpp - zdrojov kd formulru (okien)
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Tovar.h"
#include "Hudba.h"
#include "Find.h"
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
  char buf[16];
  DWORD dwSize;

  Odd = new Oddelenie;
  Odd->ZoznamTovaru = new TList;
  Odd->ZoznamNakupov = new TList;

  hFileTovar = CreateFile("tovar.dtb", GENERIC_READ | GENERIC_WRITE,
                          FILE_SHARE_READ, NULL, OPEN_ALWAYS,
                          FILE_ATTRIBUTE_NORMAL, NULL);
  hFileNakupy = CreateFile("nakupy.dtb", GENERIC_READ | GENERIC_WRITE,
                           FILE_SHARE_READ, NULL, OPEN_ALWAYS,
                           FILE_ATTRIBUTE_NORMAL, NULL);
  if (hFileTovar == INVALID_HANDLE_VALUE || hFileNakupy == INVALID_HANDLE_VALUE) {
    Application->MessageBox("Nepodarilo sa otvori databzy programu!",
                            "Chyba", MB_OK | MB_ICONSTOP);
    Application->Terminate();
  }

  *(buf + 5) = '\0';
  dwSize = GetFileSize(hFileTovar, &drw);
  if (dwSize == 0) {
    StrCopy(buf, "TOVAR");
    WriteFile(hFileTovar, buf, 5, &drw, NULL);
  }
  else {
    if (dwSize == 0xFFFFFFFF || ReadFile(hFileTovar, buf, 5, &drw, NULL) == false
        || StrComp(buf, "TOVAR") != 0) {
      Application->MessageBox("Chyba pri tan z databzy TOVAR!",
                            "Chyba", MB_OK | MB_ICONSTOP);
      Application->Terminate();
    }
    while (SetFilePointer(hFileTovar, 0L, NULL, FILE_CURRENT) < dwSize) {
      Xhudba = new Hudba;
      if (ReadTovarFromFile(Xhudba) == false) {
        delete Xhudba;
        continue;
      }
      if (Odd->PrvyTovar == NULL)
        Odd->PrvyTovar = Xhudba;

      Xhudba->setNazov(Xhudba->getInterpret() + " - " + Xhudba->getNazovAlbumu());
      Odd->AddTovar(Xhudba);
    }
  }

  dwSize = GetFileSize(hFileNakupy, &drw);
  if (dwSize == 0) {
    StrCopy(buf, "NAKUP");
    WriteFile(hFileNakupy, buf, 5, &drw, NULL);
  }
  else {
    if (dwSize == 0xFFFFFFFF || ReadFile(hFileNakupy, buf, 5, &drw, NULL) == false
        || StrComp(buf, "NAKUP") != 0) {
      Application->MessageBox("Chyba pri tan z databzy NAKUP!",
                            "Chyba", MB_OK | MB_ICONSTOP);
      Application->Terminate();
    }

    while (SetFilePointer(hFileNakupy, 0L, NULL, FILE_CURRENT) < dwSize) {
      Xnakup = new Nakup;
      ReadNakupFromFile(Xnakup);
      if (Odd->PrvyNakup == NULL)
        Odd->PrvyNakup = Xnakup;
      Odd->AddNakup(Xnakup);
    }
  }
}
//---------------------------------------------------------------------------
__fastcall TMainForm::~TMainForm()
{
  int i;

  if (hFileTovar != INVALID_HANDLE_VALUE)
    CloseHandle(hFileTovar);
  if (hFileNakupy != INVALID_HANDLE_VALUE)
    CloseHandle(hFileNakupy);

// uvolnenie dynamicky alokovanej pamate
  for (i = 0; i < Odd->ZoznamTovaru->Count; i++) {
    Xhudba = (Hudba *)Odd->ZoznamTovaru->Items[i];
    delete Xhudba;
  }
  delete Odd->ZoznamTovaru;

  for (i = 0; i < Odd->ZoznamNakupov->Count; i++) {
    Xnakup = (Nakup *)Odd->ZoznamNakupov->Items[i];
    for (int j = 0; j < Xnakup->ZoznamNakupu->Count; j++) {
      Xpolozka = (PolozkaNakupu *)Xnakup->ZoznamNakupu->Items[j];
      delete Xpolozka;
    }
    delete Xnakup;
  }
  delete Odd->ZoznamNakupov;

  delete(Odd);

  if (TabSheetNovyNakup->TabVisible == true) {
    for (i = 0; i < CurrentNakup.ZoznamNakupu->Count; i++) {
      Xpolozka = (PolozkaNakupu *)CurrentNakup.ZoznamNakupu->Items[i];
      delete Xpolozka;
    }
    delete CurrentNakup.ZoznamNakupu;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  ComboBoxZarucnaDoba->Clear();
  for (int i = 0; i < MAX_ZARUKA_ITEMS; i++) {
    CurrentTovar.setZarucnaDoba(GT_INDEX, i);
    ComboBoxZarucnaDoba->Items->Add(CurrentTovar.getZarucnaDoba(GT_TEXT, i));
  }

  TabSheetNovyNakup->TabVisible = false;
  TabSheetUdajeoTovare->TabVisible = false;

  Application->Title = CurrentTovar.getOddelenie();
  MainForm->Caption = CurrentTovar.getOddelenie();
  ComboBoxDruhTovaru->Clear();
  ComboBoxDruhTovaru->Items->Add(CurrentTovar.getDruh());
  ComboBoxDruhTovaru->ItemIndex = 0;
  ComboBoxDruhTovaru2->Clear();
  ComboBoxDruhTovaru2->Items->Add(CurrentTovar.getDruh());
  ComboBoxDruhTovaru2->ItemIndex = 0;

  Odd->TovarSorting(true);
  if (Odd->ZoznamTovaru->Count > 0)
    AktualTovar = 0;
  else
    AktualTovar = -1;

  if (Odd->ZoznamNakupov->Count > 0)
    AktualNakup = 0;
  else
    AktualNakup = -1;

  NakupovaneMnozstvo = 0;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::KoniecClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::OprogrameClick(TObject *Sender)
{
  Application->MessageBox("Roman Brik, TE010062, 2. ronk DI\nKPI FEI TU \
Koice\nZadanie z predmetu Objektovo orientovan programovanie\
\nVytvoren vo vvojovom prostred C++ Builder 5.0\nMarec - Mj 2003",
                          "O programe...", MB_OK | MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::VycistitdatabazuClick(TObject *Sender)
{
  char buf[16];
  Hudba Cur = CurrentTovar;

  CloseHandle(hFileTovar);
  DeleteFile("tovar.old");
  RenameFile("tovar.dtb", "tovar.old");
  hFileTovar = CreateFile("tovar.dtb", GENERIC_READ | GENERIC_WRITE,
                          FILE_SHARE_READ, NULL, CREATE_ALWAYS,
                          FILE_ATTRIBUTE_NORMAL, NULL);
  if (hFileTovar == INVALID_HANDLE_VALUE) {
    Application->MessageBox("Nepodarilo sa vytvori databzu programu!",
                            "Chyba", MB_OK | MB_ICONSTOP);
    RenameFile("tovar.old", "tovar.dtb");
    Close();
  }
  StrCopy(buf, "TOVAR");
  WriteFile(hFileTovar, buf, 5, &drw, NULL);

  for (int i = 0; i < Odd->ZoznamTovaru->Count; i++) {
    Xhudba = (Hudba *)Odd->ZoznamTovaru->Items[i];
    CurrentTovar = *Xhudba;
    StoreCurrentTovar();
  }

  Application->MessageBox("Databza tovaru je vyisten!", "Odelenie - Hudba",
                          MB_OK | MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CheckBoxZoraditTovarClick(TObject *Sender)
{
  if (CheckBoxZoraditTovar->Checked)
    Odd->TovarSorting(true);
  else
    Odd->UpdateTovar();

  ListBoxZoznamTovaru->Tag = 1;
  TabSheetZoznamTovaruShow(NULL);
  ListBoxZoznamTovaruClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TabSheetZoznamTovaruShow(TObject *Sender)
{
  if (Odd->ZoznamTovaru->Count != ListBoxZoznamTovaru->Items->Count
      || ListBoxZoznamTovaru->Tag == 1) {
    ListBoxZoznamTovaru->Tag = 0;
    ListBoxZoznamTovaru->Clear();
    Xhudba = Odd->PrvyTovar;
    while (Xhudba != NULL) {
      ListBoxZoznamTovaru->Items->Add(Xhudba->getNazov());
      Xhudba = Xhudba->pDalsi;
    }
    ListBoxZoznamTovaru->ItemIndex = 0;
  }

  LabelTovarPocet->Caption = Odd->ZoznamTovaru->Count;
  if (Odd->ZoznamTovaru->Count == 0) {
    ButtonUpravit->Enabled = false;
    ButtonZmazTovar->Enabled = false;
    EditNajdiTovar->Enabled = false;
    EditNajdiTovar->Text = "";
    EditNakupovaneMnozstvo->Enabled = false;
    EditNakupovaneMnozstvo->Text = "";
  }
  else {
    ButtonUpravit->Enabled = true;
    ButtonZmazTovar->Enabled = true;
    EditNajdiTovar->Enabled = true;
    EditNakupovaneMnozstvo->Enabled = true;
  }

  if (ListBoxZoznamTovaru->ItemIndex == -1) {
    ButtonUpravit->Enabled = false;
    ButtonZmazTovar->Enabled = false;
  }
  else {
    ButtonUpravit->Enabled = true;
    ButtonZmazTovar->Enabled = true;
  }

  if (EditNajdiTovar->Text.IsEmpty())
    ButtonNajdiTovar->Enabled = false;
  else
    ButtonNajdiTovar->Enabled = true;
    
  ListBoxZoznamTovaruClick(NULL);
  if (ListBoxZoznamTovaru->Items->Count > 0)
    ListBoxZoznamTovaru->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ListBoxZoznamTovaruClick(TObject *Sender)
{
  if (ListBoxZoznamTovaru->ItemIndex == -1 || ListBoxZoznamTovaru->Items->Count == 0) {
    LabelZoznamTovaruNaSklade->Caption = "";
    LabelZoznamTovaruCena->Caption = "";
    LabelNakupovaneMnozstvoJednotka->Caption = "";
    LabelNosic->Caption = "";
    EditNakupovaneMnozstvo->Text = "";
    ButtonPridajDoNakupu->Enabled = false;
    ButtonUpravit->Enabled = false;
    ButtonZmazTovar->Enabled = false;
    DateTimePickerDatumVyroby->DateTime = 0;
    AktualTovar = -1;
    return;
  }

  AktualTovar = ListBoxZoznamTovaru->ItemIndex;
  Xhudba = Odd->TovarByIndex(AktualTovar);
  TVarRec args[] = { Xhudba->getMnozstvo(), Xhudba->getMernaJednotka() };
  LabelZoznamTovaruNaSklade->Caption = AnsiString::Format("%.2f %s", args, 1);
  args[0] = Xhudba->getJednotkovaCena();
  LabelZoznamTovaruCena->Caption = AnsiString::Format("%.2f Sk", args, 0);
  LabelNakupovaneMnozstvoJednotka->Caption = Xhudba->getMernaJednotka();
  LabelNosic->Caption = ComboBoxNosic->Items->Strings[Xhudba->getNosic()];

  CurrentTovar = *Xhudba;
  NakupovaneMnozstvoUpdate();
  if (TabSheetNovyNakup->TabVisible == false)
    TabSheetUdajeoTovare->TabVisible = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ListBoxZoznamTovaruDblClick(TObject *Sender)
{
  if (ListBoxZoznamTovaru->ItemIndex == -1 || ListBoxZoznamTovaru->Items->Count == 0)
    return;
  TabSheetUdajeoTovare->Show();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TabSheetUdajeoTovareShow(TObject *Sender)
{
  FillPageUdajeTovaru();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonDalsiTovarClick(TObject *Sender)
{
  TButton *pTB = (TButton *)Sender;

  switch (pTB->TabOrder) {
    case 0 :
      AktualTovar--;
      if (AktualTovar == 0)
        pTB->Enabled = false;
      break;
    case 1 :
      AktualTovar++;
      if (AktualTovar >= Odd->ZoznamTovaru->Count - 1)
        pTB->Enabled = false;
      break;
  }

  FillPageUdajeTovaru();
  ListBoxZoznamTovaru->ItemIndex = AktualTovar;
  ListBoxZoznamTovaruClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonNovyPridajClick(TObject *Sender)
{
  switch (PageControl->Tag) {
    case 0 : // bude sa editovat
      TabSheetUdajeoTovare->TabVisible = true;
      PageControl->ActivePageIndex = 1;
      PageControl->Tag = 1;
      TabSheetZoznamTovaru->TabVisible = false;
      TabSheetZoznamNakupov->TabVisible = false;
      ButtonNovyPridaj->Caption = "Pridaj";
      ButtonNovyPridaj->Enabled = false;
      ButtonZmazZrus->Caption = "Zrui";
      ButtonUpravZapis->Visible = false;
      FillPageUdajeTovaru(true, true);
      ButtonPredoslyTovar->Enabled = false;
      ButtonNasledujuciTovar->Enabled = false;
      EditInterpret->SetFocus();
      break;
    case 1 : // koniec editacie - pridanie na koniec databazy
    case 2 : // pokracovanie po uprave udajov - -||-
      StoreCurrentTovar();
      SetFilePointer(hFileTovar, (LONG) CurrentTovar.dwFilePos, NULL, FILE_BEGIN);
      Xhudba = new Hudba;
      ReadTovarFromFile(Xhudba);
      Xhudba->setNazov(Xhudba->getInterpret() + " - " + Xhudba->getNazovAlbumu());
      Odd->AddTovar(Xhudba);
      AktualTovar = Odd->IndexOfTovar(Xhudba);
      PageControl->ActivePageIndex = 1;
      ButtonZmazZrusClick(NULL);
      break;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonUpravZapisClick(TObject *Sender)
{
  char cx = 0xFF;

  switch (PageControl->Tag) {
    case 0 : // budu sa upravovat udaje tovaru
      TabSheetUdajeoTovare->TabVisible = true;
      PageControl->ActivePageIndex = 1;
      PageControl->Tag = 2;
      TabSheetZoznamTovaru->TabVisible = false;
      TabSheetZoznamNakupov->TabVisible = false;
      ButtonNovyPridaj->Visible = false;
      ButtonZmazZrus->Caption = "Zrui";
      ButtonUpravZapis->Caption = "Zap zmeny";
      ButtonUpravZapis->Enabled = true;
      FillPageUdajeTovaru(true);
      ButtonPredoslyTovar->Enabled = false;
      ButtonNasledujuciTovar->Enabled = false;
      EditInterpret->SetFocus();
      break;
    case 2 : // budu sa zapisovat upravene udaje tovaru
      SetFilePointer(hFileTovar, (LONG) CurrentTovar.dwFilePos + 4L, NULL, FILE_BEGIN);
      WriteFile(hFileTovar, &cx, 1, &drw, NULL);
      Xhudba = Odd->TovarByIndex(AktualTovar);
      if (Xhudba == Odd->PrvyTovar)
        ListBoxZoznamTovaru->Items->Delete(0);
      else
        ListBoxZoznamTovaru->Items->Delete(AktualTovar);
      ListBoxZoznamTovaru->Tag = 1;
      Odd->DeleteTovar(Xhudba);
      Xhudba = NULL;
      ButtonNovyPridajClick(NULL);
      break;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonZmazZrusClick(TObject *Sender)
{
  char cx = 0xFF;

  switch (PageControl->Tag) {
    case 0 : // bude sa mazat z databazy
      if (Application->MessageBox("Zmaza tento tovar?", "Odelenie Hudby",
                                  MB_YESNO | MB_ICONQUESTION) == IDNO)
        return;
      SetFilePointer(hFileTovar, (LONG) CurrentTovar.dwFilePos + 4L, NULL, FILE_BEGIN);
      WriteFile(hFileTovar, &cx, 1, &drw, NULL);
      ListBoxZoznamTovaru->Items->Delete(AktualTovar);
      Xhudba = Odd->TovarByIndex(AktualTovar);
      Odd->DeleteTovar(Xhudba);
//      Xhudba = NULL;
      if (Odd->ZoznamTovaru->Count > 0)
        AktualTovar = 0;
      else
        AktualTovar = -1;
      PageControl->ActivePageIndex = 0;
      ListBoxZoznamTovaru->Tag = 1;
      TabSheetZoznamTovaruShow(NULL);
      ListBoxZoznamTovaruClick(NULL);
      break;
    case 1 : // bola zrusena editacia udajov tovaru
    case 2 :
      PageControl->Tag = 0;
      TabSheetZoznamTovaru->TabVisible = true;
      TabSheetZoznamNakupov->TabVisible = true;
      ButtonNovyPridaj->Caption = "Nov tovar";
      ButtonNovyPridaj->Enabled = true;
      ButtonNovyPridaj->Visible = true;
      ButtonUpravZapis->Caption = "Upravi daje";
      ButtonUpravZapis->Enabled = true;
      ButtonUpravZapis->Visible = true;
      ButtonZmazZrus->Caption = "Zma tovar";
      FillPageUdajeTovaru();
      break;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditEnter(TObject *Sender)
{
  if (Sender->ClassNameIs("TEdit")) {
    TEdit *pMI = (TEdit *)Sender;
    pMI->Color = clInfoBk;
  }
  if (Sender->ClassNameIs("TDateTimePicker")) {
    TDateTimePicker *pMI = (TDateTimePicker *)Sender;
    pMI->Color = clInfoBk;
  }
  if (Sender->ClassNameIs("TComboBox")) {
    TComboBox *pMI = (TComboBox *)Sender;
    pMI->Color = clInfoBk;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditExit(TObject *Sender)
{
  bool bErr = false;
  int iTO = -1;

  if (Sender != NULL && Sender->ClassNameIs("TEdit")) {
    TEdit *pTE = (TEdit *)Sender;
    pTE->Color = clWindow;
    iTO = pTE->TabOrder;

    switch (iTO) {
      case 4 :
      case 5 :
        CurrentTovar.setInterpret(EditInterpret->Text);
        CurrentTovar.setNazovAlbumu(EditAlbum->Text);
        CurrentTovar.setNazov(EditNazovTovaru->Text);
        break;
      case 8 :
        if (CurrentTovar.getNakupnaCenaBezDPH() < 0.0)
          bErr = true;
        break;
      case 9 :
        if (CurrentTovar.getSadzbaDPH() < 0.0)
          bErr = true;
        break;
      case 10 :
        if (CurrentTovar.getPredajnaCenasDPH() < 0.0)
          bErr = true;
        break;
      case 13 :
        if (CurrentTovar.getMnozstvo() < 0.0)
          bErr = true;
        break;
      case 15 :
        if (CurrentTovar.getJednotkovaCena() < 0.0)
          bErr = true;
        break;
    }
    if (bErr) {
      MessageBeep(0xFFFFFFFF);
      pTE->SetFocus();
      return;
    }
  }

  if (Sender != NULL && Sender->ClassNameIs("TDateTimePicker")) {
    TDateTimePicker *pDT = (TDateTimePicker *)Sender;
    pDT->Color = clWindow;
  }

  if (Sender != NULL && Sender->ClassNameIs("TComboBox")) {
    TComboBox *pCB = (TComboBox *)Sender;
    pCB->Color = clWindow;
    if (pCB->ItemIndex == -1) {
      MessageBeep(0xFFFFFFFF);
      pCB->SetFocus();
      return;
    }
  }

  if (iTO == 8 || iTO == 9)
    CurrentTovar.setPredajnaCenasDPH(CurrentTovar.getNakupnaCenaBezDPH()
     + CurrentTovar.getNakupnaCenaBezDPH() * CurrentTovar.getSadzbaDPH() / 100);
  if (iTO == 10)
    CurrentTovar.setNakupnaCenaBezDPH(100 * CurrentTovar.getPredajnaCenasDPH()
                                         / (100 + CurrentTovar.getSadzbaDPH()));

  VyplnUdajeTovaru();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditNazovChange(TObject *Sender)
{
  EditNazovTovaru->Text = EditInterpret->Text + " - " + EditAlbum->Text;
  EditTestTovar();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::NakupnaCenaChange(TObject *Sender)
{
  static bool bChangeNC;
  bool bd;
  int ii;
  float kf, tf;
  AnsiString aNum;

  if (bChangeNC == true) {
    bChangeNC = false;
    return;
  }

  aNum = EditNakupnaCena->Text;
  if (aNum.IsEmpty())
    CurrentTovar.setNakupnaCenaBezDPH(0.0);
  else {
    bd = false;
    for (ii = 1; ii <= aNum.Length(); ii++) {
      if ( !(isdigit(aNum[ii])|| aNum[ii] == '.' || aNum[ii] == ',')) {
        aNum = aNum.Delete(ii, 1);
        bChangeNC = true;
        continue;
      }
      if (aNum[ii] == '.' || aNum[ii] == ',') {
        if (bd == false)
          bd = true;
        else {
          aNum = aNum.Delete(ii, 1);
          bChangeNC = true;
        }
      }
    }
    if (bChangeNC)
      MessageBeep(0xFFFFFFFF);

    if (aNum.IsEmpty())
      aNum = "0";
    ChangeDecSep(aNum);
    tf = aNum.ToDouble();
    aNum = aNum.FloatToStrF(tf, AnsiString::sffFixed, 7, 2);
    kf = aNum.ToDouble();
    if (kf == tf)
      CurrentTovar.setNakupnaCenaBezDPH(kf);
    else {
      bChangeNC = true;
      aNum = aNum.FloatToStrF(CurrentTovar.getNakupnaCenaBezDPH(), AnsiString::sffFixed, 7, 2);
    }
  }

  if (bChangeNC)
    EditNakupnaCena->Text = aNum;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditDPHChange(TObject *Sender)
{
  static bool bChangeDC;
  bool bd;
  int ii;
  float kf, tf;
  AnsiString aNum;

  if (bChangeDC == true) {
    bChangeDC = false;
    return;
  }

  aNum = EditDPH->Text;
  if (aNum.IsEmpty())
    CurrentTovar.setSadzbaDPH(0.0);
  else {
    bd = false;
    for (ii = 1; ii <= aNum.Length(); ii++) {
      if ( !(isdigit(aNum[ii])|| aNum[ii] == '.' || aNum[ii] == ',')) {
        aNum = aNum.Delete(ii, 1);
        bChangeDC = true;
        continue;
      }
      if (aNum[ii] == '.' || aNum[ii] == ',') {
        if (bd == false)
          bd = true;
        else {
          aNum = aNum.Delete(ii, 1);
          bChangeDC = true;
        }
      }
    }
    if (bChangeDC)
      MessageBeep(0xFFFFFFFF);

    if (aNum.IsEmpty())
      aNum = "0";
    ChangeDecSep(aNum);
    tf = aNum.ToDouble();
    aNum = aNum.FloatToStrF(tf, AnsiString::sffFixed, 7, 1);
    kf = aNum.ToDouble();
    if (kf == tf)
      CurrentTovar.setSadzbaDPH(kf);
    else {
      bChangeDC = true;
      aNum = aNum.FloatToStrF(CurrentTovar.getSadzbaDPH(), AnsiString::sffFixed, 7, 1);
    }
  }

  if (bChangeDC)
    EditDPH->Text = aNum;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditPredajnaCenaChange(TObject *Sender)
{
  static bool bChangePC;
  bool bd;
  int ii;
  float kf, tf;
  AnsiString aNum;

  if (bChangePC == true) {
    bChangePC = false;
    return;
  }

  aNum = EditPredajnaCena->Text;
  if (aNum.IsEmpty())
    CurrentTovar.setPredajnaCenasDPH(0.0);
  else {
    bd = false;
    for (ii = 1; ii <= aNum.Length(); ii++) {
      if ( !(isdigit(aNum[ii])|| aNum[ii] == '.' || aNum[ii] == ',')) {
        aNum = aNum.Delete(ii, 1);
        bChangePC = true;
        continue;
      }
      if (aNum[ii] == '.' || aNum[ii] == ',') {
        if (bd == false)
          bd = true;
        else {
          aNum = aNum.Delete(ii, 1);
          bChangePC = true;
        }
      }
    }
    if (bChangePC)
      MessageBeep(0xFFFFFFFF);

    if (aNum.IsEmpty())
      aNum = "0";
    ChangeDecSep(aNum);
    tf = aNum.ToDouble();
    aNum = aNum.FloatToStrF(tf, AnsiString::sffFixed, 7, 2);
    kf = aNum.ToDouble();
    if (kf == tf)
      CurrentTovar.setPredajnaCenasDPH(kf);
    else {
      bChangePC = true;
      aNum = aNum.FloatToStrF(CurrentTovar.getPredajnaCenasDPH(), AnsiString::sffFixed, 7, 2);
    }
  }

  if (bChangePC)
    EditPredajnaCena->Text = aNum;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditStavNaSkladeChange(TObject *Sender)
{
  static bool bChangeSS;
  bool bd;
  int ii;
  float kf, tf;
  AnsiString aNum;

  if (bChangeSS == true) {
    bChangeSS = false;
    return;
  }

  aNum = EditStavNaSklade->Text;
  if (aNum.IsEmpty())
    CurrentTovar.setMnozstvo(0.0);
  else {
    bd = false;
    for (ii = 1; ii <= aNum.Length(); ii++) {
      if ( !(isdigit(aNum[ii])|| aNum[ii] == '.' || aNum[ii] == ',')) {
        aNum = aNum.Delete(ii, 1);
        bChangeSS = true;
        continue;
      }
      if (aNum[ii] == '.' || aNum[ii] == ',') {
        if (bd == false)
          bd = true;
        else {
          aNum = aNum.Delete(ii, 1);
          bChangeSS = true;
        }
      }
    }
    if (bChangeSS)
      MessageBeep(0xFFFFFFFF);

    if (aNum.IsEmpty())
      aNum = "0";
    ChangeDecSep(aNum);
    tf = aNum.ToDouble();
    aNum = aNum.FloatToStrF(tf, AnsiString::sffFixed, 7, 2);
    kf = aNum.ToDouble();
    if (kf == tf)
      CurrentTovar.setMnozstvo(kf);
    else {
      bChangeSS = true;
      aNum = aNum.FloatToStrF(CurrentTovar.getMnozstvo(), AnsiString::sffFixed, 7, 2);
    }
  }

  if (bChangeSS)
    EditStavNaSklade->Text = aNum;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditMernaJednotkaChange(TObject *Sender)
{
  CurrentTovar.setMernaJednotka(EditMernaJednotka->Text);
  EditTestTovar();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditJednotkovaCenaChange(TObject *Sender)
{
  static bool bChangeJC;
  bool bd;
  int ii;
  float kf, tf;
  AnsiString aNum;

  if (bChangeJC == true) {
    bChangeJC = false;
    return;
  }

  aNum = EditJednotkovaCena->Text;
  if (aNum.IsEmpty())
    CurrentTovar.setJednotkovaCena(0.0);
  else {
    bd = false;
    for (ii = 1; ii <= aNum.Length(); ii++) {
      if ( !(isdigit(aNum[ii])|| aNum[ii] == '.' || aNum[ii] == ',')) {
        aNum = aNum.Delete(ii, 1);
        bChangeJC = true;
        continue;
      }
      if (aNum[ii] == '.' || aNum[ii] == ',') {
        if (bd == false)
          bd = true;
        else {
          aNum = aNum.Delete(ii, 1);
          bChangeJC = true;
        }
      }
    }
    if (bChangeJC)
      MessageBeep(0xFFFFFFFF);

    if (aNum.IsEmpty())
      aNum = "0";
    ChangeDecSep(aNum);
    tf = aNum.ToDouble();
    aNum = aNum.FloatToStrF(tf, AnsiString::sffFixed, 7, 2);
    kf = aNum.ToDouble();
    if (kf == tf)
      CurrentTovar.setJednotkovaCena(kf);
    else {
      bChangeJC = true;
      aNum = aNum.FloatToStrF(CurrentTovar.getJednotkovaCena(), AnsiString::sffFixed, 7, 2);
    }
  }

  if (bChangeJC)
    EditJednotkovaCena->Text = aNum;
  EditTestTovar();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ComboBoxNosicChange(TObject *Sender)
{
  CurrentTovar.setNosic((TNosic)ComboBoxNosic->ItemIndex);
  EditTestTovar();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ComboBoxZanerChange(TObject *Sender)
{
  CurrentTovar.setZaner((TZaner)ComboBoxZaner->ItemIndex);
  EditTestTovar();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ComboBoxZarucnaDobaChange(TObject *Sender)
{
  CurrentTovar.setZarucnaDoba(GT_INDEX, ComboBoxZarucnaDoba->ItemIndex);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DateTimePickerDatumVyrobyChange(TObject *Sender)
{
  CurrentTovar.setDatumVyroby(DateTimePickerDatumVyroby->DateTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditExitZoznamTovaru(TObject *Sender)
{
  if (Sender != NULL && Sender->ClassNameIs("TEdit")) {
    TEdit *pTE = (TEdit *)Sender;
    pTE->Color = clWindow;
  }
  NakupovaneMnozstvoUpdate();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditNajdiTovarChange(TObject *Sender)
{
    ButtonNajdiTovar->Enabled = !EditNajdiTovar->Text.IsEmpty();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditNakupovaneMnozstvoChange(TObject *Sender)
{
  static bool bChangeNM;
  bool bd;
  int ii;
  float kf, tf;
  AnsiString aNum;

  if (bChangeNM == true) {
    bChangeNM = false;
    return;
  }

  aNum = EditNakupovaneMnozstvo->Text;
  if (aNum.IsEmpty())
    NakupovaneMnozstvo = 0;
  else {
    bd = false;
    for (ii = 1; ii <= aNum.Length(); ii++) {
      if ( !(isdigit(aNum[ii])|| aNum[ii] == '.' || aNum[ii] == ',')) {
        aNum = aNum.Delete(ii, 1);
        bChangeNM = true;
        continue;
      }
      if (aNum[ii] == '.' || aNum[ii] == ',') {
        if (bd == false)
          bd = true;
        else {
          aNum = aNum.Delete(ii, 1);
          bChangeNM = true;
        }
      }
    }
    if (bChangeNM)
      MessageBeep(0xFFFFFFFF);

    if (aNum.IsEmpty())
      aNum = "0";
    ChangeDecSep(aNum);
    tf = aNum.ToDouble();
    aNum = aNum.FloatToStrF(tf, AnsiString::sffFixed, 7, 2);
    kf = aNum.ToDouble();
    if (kf == tf)
      NakupovaneMnozstvo = kf;
    else {
      bChangeNM = true;
      aNum = aNum.FloatToStrF(NakupovaneMnozstvo, AnsiString::sffFixed, 7, 2);
    }
  }
  NakupovaneMnozstvoUpdate(true);

  if (bChangeNM)
    EditNakupovaneMnozstvo->Text = aNum;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonNajdiTovarClick(TObject *Sender)
{
  int ii = Odd->FindTovar(EditNajdiTovar->Text, ListBoxZoznamTovaru->ItemIndex + 1);
  if (ii < 0)
    return;
  ListBoxZoznamTovaru->ItemIndex = ii;
  AktualTovar = ii;
  ListBoxZoznamTovaruClick(NULL);
  TabSheetZoznamTovaruShow(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TabSheetZoznamNakupovShow(TObject *Sender)
{
  TListItem *LI;
  AnsiString aX;

  if (Odd->ZoznamNakupov->Count != ListViewZoznamNakupov->Items->Count
      || ListViewZoznamNakupov->Tag == -1) {
    ListViewZoznamNakupov->Tag = 0;
    ListViewZoznamNakupov->Items->BeginUpdate();
    ListViewZoznamNakupov->Items->Clear();

    Xnakup = Odd->PrvyNakup;
    while (Xnakup != NULL) {
      LI = ListViewZoznamNakupov->Items->Add();
      LI->Caption = Xnakup->getDatumNakupu().FormatString("d.m.yyyy h:nn:ss");
      aX = ValueToStr(aX, Xnakup->getCenaNakupu(), true);
      LI->SubItems->Add(aX);
      Xnakup = Xnakup->pDalsi;
    }
    ListViewZoznamNakupov->Items->EndUpdate();
  }
  LabelPocetNakupov->Caption = Odd->ZoznamNakupov->Count;
  if (ListViewZoznamNakupov->Items->Count > 0)
    ListViewZoznamNakupov->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ListViewZoznamNakupovClick(TObject *Sender)
{
  if (ListViewZoznamNakupov->Selected == NULL
      || ListViewZoznamNakupov->ItemFocused == NULL) {
    ListViewPolozkyNakupu->Items->Clear();
    ListViewPolozkyNakupu->Tag = -1;
    return;
  }

  Xnakup = Odd->NakupByIndex(ListViewZoznamNakupov->Selected->Index);
  if (Xnakup == NULL)
    return;
  if (ListViewZoznamNakupov->ItemFocused->Index != ListViewPolozkyNakupu->Tag) {
    VyplnListViewNakupov(ListViewPolozkyNakupu, Xnakup->ZoznamNakupu);
    ListViewPolozkyNakupu->Tag = ListViewZoznamNakupov->ItemFocused->Index;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ListViewZoznamNakupovKeyUp(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
  ListViewZoznamNakupovClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RadioGroupZotriedNakupyClick(TObject *Sender)
{
  Odd->NakupSorting(RadioGroupZotriedNakupy->ItemIndex);
  ListViewZoznamNakupov->Tag = -1;
  TabSheetZoznamNakupovShow(NULL);
  ListViewZoznamNakupovClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonNovyNakupClick(TObject *Sender)
{
  TabSheetNovyNakup->TabVisible = true;
  if (Sender != NULL)
    PageControl->ActivePageIndex = 0;
  TabSheetUdajeoTovare->TabVisible = false;
  TabSheetZoznamNakupov->TabVisible = false;

  CurrentNakup.setDatumNakupu(TDateTime::CurrentDateTime());
  CurrentNakup.setCenaNakupu(0);
  CurrentNakup.ZoznamNakupu = new TList;
  CurrentNakup.pDalsi = NULL;
  VyplnNovyNakup();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonPridajDoNakupuClick(TObject *Sender)
{
  if (TabSheetNovyNakup->TabVisible == false)
    ButtonNovyNakupClick(NULL);
  PageControl->ActivePageIndex = 3;
  Xpolozka = new PolozkaNakupu;
  Xpolozka->Nazov = CurrentTovar.getNazov();
  Xpolozka->Mnozstvo = NakupovaneMnozstvo;
  Xpolozka->Cena = CurrentTovar.getJednotkovaCena();
  CurrentNakup.ZoznamNakupu->Add(Xpolozka);
  CurrentNakup.setCenaNakupu(CurrentNakup.getCenaNakupu()
                             + Xpolozka->Cena * NakupovaneMnozstvo);
  VyplnNovyNakup();
  ButtonDalsiTovar->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonZrusNakupClick(TObject *Sender)
{
  TabSheetUdajeoTovare->TabVisible = true;
  TabSheetZoznamNakupov->TabVisible = true;
  TabSheetNovyNakup->TabVisible = false;
  PageControl->ActivePageIndex = 2;

  for (int i = 0; i < CurrentNakup.ZoznamNakupu->Count; i++) {
    Xpolozka = (PolozkaNakupu *)CurrentNakup.ZoznamNakupu->Items[i];
    delete Xpolozka;
  }
  delete CurrentNakup.ZoznamNakupu;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonDalsiTovarDoNakupuClick(TObject *Sender)
{
  PageControl->ActivePageIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonNovyNakupOKClick(TObject *Sender)
{
  StoreNewNakup();
  SetFilePointer(hFileNakupy, (LONG)CurrentNakup.dwFilePos, NULL, FILE_BEGIN);
  Xnakup = new Nakup;
  ReadNakupFromFile(Xnakup);
  Odd->AddNakup(Xnakup);

  for (int i = 0; i < CurrentNakup.ZoznamNakupu->Count; i++) {
    Xpolozka = (PolozkaNakupu *)CurrentNakup.ZoznamNakupu->Items[i];
    delete Xpolozka;
  }
  delete CurrentNakup.ZoznamNakupu;

  TabSheetUdajeoTovare->TabVisible = true;
  TabSheetZoznamNakupov->TabVisible = true;
  TabSheetNovyNakup->TabVisible = false;
  PageControl->ActivePageIndex = 2;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BestSellerClick(TObject *Sender)
{
  FormFind->ShowModal();
}
//---------------------------------------------------------------------------
//***************************************************************************
//---------------------------------------------------------------------------
void __fastcall TMainForm::ChangeDecSep(AnsiString& aS)
{
  int ia;

  if ((ia = aS.LastDelimiter(",.")) > 0) {
    aS = aS.Delete(ia, 1);
    aS = aS.Insert(DecimalSeparator, ia);
  }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMainForm::ValueToStr(AnsiString Text, float Value, bool Halier)
{
  if (Halier)
    return Text.FloatToStrF(Value, AnsiString::sffFixed, 7, 1) + "0";
  else
    return Text.FloatToStrF(Value, AnsiString::sffFixed, 7, 1);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::VyplnUdajeTovaru()
{
    EditInterpret->Text = CurrentTovar.getInterpret();
    EditAlbum->Text = CurrentTovar.getNazovAlbumu();
    EditNazovTovaru->Text = EditInterpret->Text + " - " + EditAlbum->Text;
    ComboBoxNosic->ItemIndex = CurrentTovar.getNosic();
    ComboBoxZaner->ItemIndex = CurrentTovar.getZaner();
    EditNakupnaCena->Text = ValueToStr(EditNakupnaCena->Text,
                                       CurrentTovar.getNakupnaCenaBezDPH(), true);
    EditDPH->Text = ValueToStr(EditDPH->Text, CurrentTovar.getSadzbaDPH(), false);
    EditPredajnaCena->Text = ValueToStr(EditPredajnaCena->Text,
                                        CurrentTovar.getPredajnaCenasDPH(), true);
    DateTimePickerDatumVyroby->DateTime = CurrentTovar.getDatumVyroby();
    CurrentTovar.getZarucnaDoba(GT_INDEX, Xint);
    ComboBoxZarucnaDoba->ItemIndex = Xint;
    EditStavNaSklade->Text = ValueToStr(EditStavNaSklade->Text,
                                        CurrentTovar.getMnozstvo(), true);
    EditMernaJednotka->Text = CurrentTovar.getMernaJednotka();
    EditJednotkovaCena->Text = ValueToStr(EditJednotkovaCena->Text,
                                        CurrentTovar.getJednotkovaCena(), true);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::NakupovaneMnozstvoUpdate(bool OnEdit)
{
  if (OnEdit == False)
    EditNakupovaneMnozstvo->Text = ValueToStr(EditNakupovaneMnozstvo->Text,
                                              NakupovaneMnozstvo, true);
  if (NakupovaneMnozstvo <= 0 || NakupovaneMnozstvo > CurrentTovar.getMnozstvo())
    ButtonPridajDoNakupu->Enabled = false;
  else
    ButtonPridajDoNakupu->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditTestTovar()
{
  bool bE = false;

  if (!EditInterpret->Text.IsEmpty()
      && !EditAlbum->Text.IsEmpty()
      && CurrentTovar.getNosic() > -1
      && CurrentTovar.getZaner() > -1
      && !CurrentTovar.getMernaJednotka().IsEmpty()
      && CurrentTovar.getJednotkovaCena() > 0)
    bE = true;

  if (PageControl->Tag == 2)
    ButtonUpravZapis->Enabled = bE;
  else
    ButtonNovyPridaj->Enabled = bE;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FillPageUdajeTovaru(bool Edit, bool New)
{
  if (AktualTovar < 1)
    ButtonPredoslyTovar->Enabled = false;
  else
    ButtonPredoslyTovar->Enabled = true;
  if (AktualTovar + 1 < Odd->ZoznamTovaru->Count)
    ButtonNasledujuciTovar->Enabled = true;
  else
    ButtonNasledujuciTovar->Enabled = false;

  if (Edit || New) {
    EditNakupnaCena->Enabled = true;
    EditDPH->Enabled = true;
    EditPredajnaCena->Enabled = true;
    DateTimePickerDatumVyroby->Enabled = true;
    ComboBoxZarucnaDoba->Enabled = true;
    EditStavNaSklade->Enabled = true;
    EditMernaJednotka->Enabled = true;
    EditJednotkovaCena->Enabled = true;
    EditInterpret->Enabled = true;
    EditAlbum->Enabled = true;
    ComboBoxNosic->Enabled = true;
    ComboBoxZaner->Enabled = true;
  }
  else {
    EditNakupnaCena->Enabled = false;
    EditDPH->Enabled = false;
    EditPredajnaCena->Enabled = false;
    DateTimePickerDatumVyroby->Enabled = false;
    ComboBoxZarucnaDoba->Enabled = false;
    EditStavNaSklade->Enabled = false;
    EditMernaJednotka->Enabled = false;
    EditJednotkovaCena->Enabled = false;
    EditInterpret->Enabled = false;
    EditAlbum->Enabled = false;
    ComboBoxNosic->Enabled = false;
    ComboBoxZaner->Enabled = false;
  }

  if (New || AktualTovar < 0) {
    CurrentTovar.setInterpret("");
    CurrentTovar.setNazovAlbumu("");
    CurrentTovar.setNazov("");
    CurrentTovar.setNosic(HN_NONE);
    CurrentTovar.setZaner(ZN_NONE);
    CurrentTovar.setNakupnaCenaBezDPH(0.0);
    CurrentTovar.setSadzbaDPH(0.0);
    CurrentTovar.setPredajnaCenasDPH(0.0);
    CurrentTovar.setDatumVyroby(TDateTime::CurrentDateTime());
    CurrentTovar.setZarucnaDoba(GT_VALUE, -1);
    CurrentTovar.setMnozstvo(0.0);
    CurrentTovar.setMernaJednotka("");
    CurrentTovar.setJednotkovaCena(0.0);
  }
  else {
    Xhudba = Odd->TovarByIndex(AktualTovar);
    CurrentTovar = *Xhudba;
  }

  VyplnUdajeTovaru();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StoreCurrentTovar()
{
  char WBuffer[256], *pBuf;

  CurrentTovar.dwFilePos = SetFilePointer(hFileTovar, 0L, NULL, FILE_END);
  pBuf = WBuffer + sizeof(Xint); // vynechame miesto pre dlzku zaznamu
  *pBuf = '\0';   // informacny byte = 0, ze je zaznam platny
  pBuf++;        // pre neplatny (zmazany) zaznam je rovny 255
  StrCopy(pBuf, CurrentTovar.getInterpret().c_str());
  pBuf = pBuf + CurrentTovar.getInterpret().Length() + 1;
  StrCopy(pBuf, CurrentTovar.getNazovAlbumu().c_str());
  pBuf = pBuf + CurrentTovar.getNazovAlbumu().Length() + 1;
  Xchar = (char)CurrentTovar.getNosic();
  *pBuf = Xchar;
  pBuf++;
  Xchar = (char)CurrentTovar.getZaner();
  *pBuf = Xchar;
  pBuf++;
  Xfloat = CurrentTovar.getSadzbaDPH();
  CopyMemory(pBuf, &Xfloat, sizeof(Xfloat));
  pBuf += sizeof(Xfloat);
  Xfloat = CurrentTovar.getNakupnaCenaBezDPH();
  CopyMemory(pBuf, &Xfloat, sizeof(Xfloat));
  pBuf += sizeof(Xfloat);
  Xfloat = CurrentTovar.getPredajnaCenasDPH();
  CopyMemory(pBuf, &Xfloat, sizeof(Xfloat));
  pBuf += sizeof(Xfloat);
  Xfloat = CurrentTovar.getJednotkovaCena();
  CopyMemory(pBuf, &Xfloat, sizeof(Xfloat));
  pBuf += sizeof(Xfloat);
  Xfloat = CurrentTovar.getMnozstvo();
  CopyMemory(pBuf, &Xfloat, sizeof(Xfloat));
  pBuf += sizeof(Xfloat);
  CurrentTovar.getZarucnaDoba(GT_VALUE, Xint);
  CopyMemory(pBuf, &Xint, sizeof(Xint));
  pBuf += sizeof(Xint);
  Xdate = CurrentTovar.getDatumVyroby();
  CopyMemory(pBuf, &Xdate, sizeof(Xdate));
  pBuf += sizeof(Xdate);
  StrCopy(pBuf, CurrentTovar.getMernaJednotka().c_str());
  pBuf = pBuf + CurrentTovar.getMernaJednotka().Length() + 1;
  Xint = pBuf - WBuffer - 4;
  CopyMemory(WBuffer, &Xint, sizeof(Xint));
  WriteFile(hFileTovar, WBuffer, Xint + 4, &drw, NULL);
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::ReadTovarFromFile(Hudba *HT)
{
  char RBuffer[256], *pBuf;

  HT->dwFilePos = SetFilePointer(hFileTovar, 0L, NULL, FILE_CURRENT);
  ReadFile(hFileTovar, &Xint, sizeof(Xint), &drw, NULL);
  ReadFile(hFileTovar, RBuffer, Xint, &drw, NULL);
  pBuf = RBuffer;
  if (*pBuf != '\0')         // ak je to "zmazany" zaznam vrat sa s false
    return false;
  pBuf++;
  HT->setInterpret(pBuf);
  pBuf += HT->getInterpret().Length() + 1;
  HT->setNazovAlbumu(pBuf);
  pBuf += HT->getNazovAlbumu().Length() + 1;
  HT->setNosic((TNosic) *pBuf);
  pBuf++;
  HT->setZaner((TZaner) *pBuf);
  pBuf++;
  CopyMemory(&Xfloat, pBuf, sizeof(Xfloat));
  HT->setSadzbaDPH(Xfloat);
  pBuf += sizeof(Xfloat);
  CopyMemory(&Xfloat, pBuf, sizeof(Xfloat));
  HT->setNakupnaCenaBezDPH(Xfloat);
  pBuf += sizeof(Xfloat);
  CopyMemory(&Xfloat, pBuf, sizeof(Xfloat));
  HT->setPredajnaCenasDPH(Xfloat);
  pBuf += sizeof(Xfloat);
  CopyMemory(&Xfloat, pBuf, sizeof(Xfloat));
  HT->setJednotkovaCena(Xfloat);
  pBuf += sizeof(Xfloat);
  CopyMemory(&Xfloat, pBuf, sizeof(Xfloat));
  HT->setMnozstvo(Xfloat);
  pBuf += sizeof(Xfloat);
  CopyMemory(&Xint, pBuf, sizeof(Xint));
  HT->setZarucnaDoba(GT_VALUE, Xint);
  pBuf += sizeof(Xint);
  CopyMemory(&Xdate, pBuf, sizeof(Xdate));
  HT->setDatumVyroby(Xdate);
  pBuf += sizeof(Xdate);
  HT->setMernaJednotka(pBuf);

  return true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ReadNakupFromFile(Nakup *NR)
{
  char RBuf[128], *pBuf;
  int iP;

  ReadFile(hFileNakupy, &Xint, sizeof(Xint), &drw, NULL);
  ReadFile(hFileNakupy, RBuf, sizeof(Xdate) + sizeof(Xfloat) + sizeof(Xint),
           &drw, NULL);
  pBuf = RBuf;
  CopyMemory(&Xdate, pBuf, sizeof(Xdate));
  NR->setDatumNakupu(Xdate);
  pBuf += sizeof(Xdate);
  CopyMemory(&Xfloat, pBuf, sizeof(Xfloat));
  NR->setCenaNakupu(Xfloat);
  pBuf += sizeof(Xfloat);
  CopyMemory(&Xint, pBuf, sizeof(Xint));

  NR->ZoznamNakupu = new TList;
  while (Xint) {
    Xpolozka = new PolozkaNakupu;
    iP = 0;
    pBuf = RBuf;
    ReadFile(hFileNakupy, &iP, 1, &drw, NULL);
    ReadFile(hFileNakupy, RBuf, iP, &drw, NULL);
    Xpolozka->Nazov = RBuf;
    pBuf += Xpolozka->Nazov.Length() + 1;
    CopyMemory(&Xfloat, pBuf, sizeof(Xfloat));
    Xpolozka->Mnozstvo = Xfloat;
    pBuf += sizeof(Xfloat);
    CopyMemory(&Xfloat, pBuf, sizeof(Xfloat));
    Xpolozka->Cena = Xfloat;
    NR->ZoznamNakupu->Add(Xpolozka);
    Xint--;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StoreNewNakup()
{
  char WBuf[128], *pBuf;
  DWORD dwFilePos;
  int iRecLen, ij, iPocNak;

  CurrentNakup.dwFilePos = SetFilePointer(hFileNakupy, 0L, NULL, FILE_END);
  pBuf = WBuf + sizeof(iRecLen); // vynechame miesto pre dlzku zaznamu nakupov
  Xdate = CurrentNakup.getDatumNakupu();
  CopyMemory(pBuf, &Xdate, sizeof(Xdate));
  pBuf += sizeof(Xdate);
  Xfloat = CurrentNakup.getCenaNakupu();
  CopyMemory(pBuf, &Xfloat, sizeof(Xfloat));
  pBuf += sizeof(Xfloat);
  iPocNak = CurrentNakup.ZoznamNakupu->Count;
  CopyMemory(pBuf, &iPocNak, sizeof(Xint));
  pBuf += sizeof(Xint);
  iRecLen = pBuf - WBuf - 4;
  WriteFile(hFileNakupy, WBuf, iRecLen + 4, &drw, NULL);
  for (ij = 0; ij < iPocNak; ij++) {
    Xpolozka = (PolozkaNakupu *)CurrentNakup.ZoznamNakupu->Items[ij];
    Xint = Xpolozka->Nazov.Length() + 1 + sizeof(float) + sizeof(float);
    CopyMemory(WBuf, &Xint, 1);    // dlzka zaznamu jednej polozku nakupu
    pBuf = WBuf + 1;    // preskocime dlzku zaznamu jednej polozku nakupu
    StrCopy(pBuf, Xpolozka->Nazov.c_str());
    pBuf = pBuf + Xpolozka->Nazov.Length() + 1;
    Xfloat = Xpolozka->Mnozstvo;
    CopyMemory(pBuf, &Xfloat, sizeof(Xfloat));
    pBuf += sizeof(Xfloat);
    Xfloat = Xpolozka->Cena;
    CopyMemory(pBuf, &Xfloat, sizeof(Xfloat));
//    pBuf += sizeof(Xfloat);
    WriteFile(hFileNakupy, WBuf, Xint + 1, &drw, NULL);
    iRecLen = iRecLen + Xint + 1;
  }
  SetFilePointer(hFileNakupy, (LONG)CurrentNakup.dwFilePos, NULL, FILE_BEGIN);
  WriteFile(hFileNakupy, &iRecLen, sizeof(iRecLen), &drw, NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::VyplnListViewNakupov(TListView *LW, TList *LN)
{
  TListItem *TLI;
  AnsiString aS;

  LW->Items->BeginUpdate();
  LW->Items->Clear();
  for (int i = 0; i < LN->Count; i++) {
    Xpolozka = (PolozkaNakupu *)LN->Items[i];
    TLI = LW->Items->Add();
    TLI->Caption = Xpolozka->Nazov;
    aS = aS.FloatToStrF(Xpolozka->Mnozstvo, AnsiString::sffFixed, 7, 2);
    TLI->SubItems->Add(aS);
    aS = ValueToStr(aS, Xpolozka->Cena, true);
    TLI->SubItems->Add(aS);
  }
  LW->Items->EndUpdate();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::VyplnNovyNakup()
{
  LabelPoloziekvNakupe->Caption = CurrentNakup.ZoznamNakupu->Count;
  VyplnListViewNakupov(ListViewNovyNakup, CurrentNakup.ZoznamNakupu);
  if (CurrentNakup.ZoznamNakupu->Count > 0)
    ButtonNovyNakupOK->Enabled = true;
  else
    ButtonNovyNakupOK->Enabled = false;
  LabelNovyNakupCenaCelkom->Caption =
    ValueToStr(LabelNovyNakupCenaCelkom->Caption, CurrentNakup.getCenaNakupu(),
               true) + " Sk";
}
//---------------------------------------------------------------------------

