//---------------------------------------------------------------------------
// Roman Brik, TE010062, 2. ronk DI, KPI FEI TU Koice
// Dtum: Marec - Mj 2003
// Predmet: Objektovo orientovan programovanie
// Sbor: Tovar.cpp - zdrojov kd abstraktnej triedy Tovar
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Tovar.h"
//---------------------------------------------------------------------------
// konstruktor
__fastcall Tovar::Tovar()
{
  int iZ[MAX_ZARUKA_ITEMS] = { -1, 1, 2, 3, 4 ,5 ,6 ,7 ,14, 21, 30, 60, 90,
                               120, 150, 180, 270, 360, 540, 720, 1080 };
  for (int i = 0; i < MAX_ZARUKA_ITEMS; i++)
    Zaruka[i] = iZ[i];

  Nazov = "";
  NakupnaCenaBezDPH = 0.0;
  PredajnaCenasDPH = 0.0;
  DatumVyroby = TDateTime::CurrentDateTime();
  ZarucnaDoba = -1;
  Mnozstvo = 0.0;
  MernaJednotka = "";
  JednotkovaCena = 0.0;
}
//---------------------------------------------------------------------------
AnsiString __fastcall Tovar::getZarucnaDoba(TGT gtZD, int &iZD)
{
  switch (gtZD) {
    case GT_VALUE :
      iZD = this->ZarucnaDoba;
      return "";
    case GT_INDEX :
      int i;
      for (i = 0; i < MAX_ZARUKA_ITEMS; i++)
        if (this->ZarucnaDoba == Zaruka[i]) {
          iZD = i;
          return "";
        }
      iZD = -1;
      return "";
    case GT_TEXT :
      if (this->ZarucnaDoba < 30) {
        if (this->ZarucnaDoba < 1)
          return "Bez zruky";
        switch (this->ZarucnaDoba) {
          case 1 :
            return "1 de";
          case 2 :
          case 3 :
          case 4 :
            return IntToStr(this->ZarucnaDoba) + " dni";
          default :
            return IntToStr(this->ZarucnaDoba) + " dn";
        }
      }
      else {
        int mesiace = this->ZarucnaDoba / 30;
        switch (mesiace) {
          case 1 :
            return "1 mesiac";
          case 2 :
          case 3 :
          case 4 :
            return IntToStr(mesiace) + " mesiace";
          default :
            return IntToStr(mesiace) + " mesiacov";
         }
      }
    }
    return "";
}
//---------------------------------------------------------------------------
bool __fastcall Tovar::setZarucnaDoba(TGT gtZD, int iZD)
{
  switch (gtZD) {
    case GT_INDEX :
      if (iZD < 0 || iZD >= MAX_ZARUKA_ITEMS) {
        this->ZarucnaDoba = Zaruka[0];
        return false;
      }
      this->ZarucnaDoba = Zaruka[iZD];
      break;
    case GT_VALUE :
      if (iZD < 1) {
        this->ZarucnaDoba = Zaruka[0];
        return false;
      }
      if (iZD > Zaruka[MAX_ZARUKA_ITEMS - 1]) {
        this->ZarucnaDoba = Zaruka[MAX_ZARUKA_ITEMS - 1];
        return false;
      }
      for (int i = 1; i < MAX_ZARUKA_ITEMS; i++) {
        if (iZD == Zaruka[i]) {
          this->ZarucnaDoba = iZD;
          break;
        }
        if (iZD < Zaruka[i]) {
          this->ZarucnaDoba = Zaruka[i - 1];
          break;
        }
      }
      break;
    default :
      return false;
  }
  return true;
}
//---------------------------------------------------------------------------
void __fastcall Tovar::setNazov(AnsiString Nazov)
{
  this->Nazov = Nazov;
}
//---------------------------------------------------------------------------
AnsiString __fastcall Tovar::getNazov()
{
  return Nazov;
}
//---------------------------------------------------------------------------
void __fastcall Tovar::setNakupnaCenaBezDPH(float NakupnaCenaBezDPH)
{
  this->NakupnaCenaBezDPH = NakupnaCenaBezDPH;
}
//---------------------------------------------------------------------------
float __fastcall Tovar::getNakupnaCenaBezDPH()
{
  return NakupnaCenaBezDPH;
}
//---------------------------------------------------------------------------
void __fastcall Tovar::setPredajnaCenasDPH(float PredajnaCenasDPH)
{
  this->PredajnaCenasDPH = PredajnaCenasDPH;
}
//---------------------------------------------------------------------------
float __fastcall Tovar::getPredajnaCenasDPH()
{
  return PredajnaCenasDPH;
}
//---------------------------------------------------------------------------
void __fastcall Tovar::setDatumVyroby(TDateTime DatumVyroby)
{
  this->DatumVyroby = DatumVyroby;
}
//---------------------------------------------------------------------------
TDateTime __fastcall Tovar::getDatumVyroby()
{
  return DatumVyroby;
}
//---------------------------------------------------------------------------
void __fastcall Tovar::setMnozstvo(float Mnozstvo)
{
  this->Mnozstvo = Mnozstvo;
}
//---------------------------------------------------------------------------
float __fastcall Tovar::getMnozstvo()
{
  return Mnozstvo;
}
//---------------------------------------------------------------------------
void __fastcall Tovar::setMernaJednotka(AnsiString MernaJednotka)
{
  this->MernaJednotka = MernaJednotka;
}
//---------------------------------------------------------------------------
AnsiString __fastcall Tovar::getMernaJednotka()
{
  return MernaJednotka;
}
//---------------------------------------------------------------------------
void __fastcall Tovar::setJednotkovaCena(float JednotkovaCena)
{
  this->JednotkovaCena = JednotkovaCena;
}
//---------------------------------------------------------------------------
float __fastcall Tovar::getJednotkovaCena()
{
  return JednotkovaCena;
}
//---------------------------------------------------------------------------

